#include <stdio.h>
#include <string.h>
#include "main.h"


void _zpu_interrupt(void) {
	interrupt = *interrupt_stat;
	if ((interrupt & 0x04) != 0) {
		keyboard_recv();
	}
	if ((interrupt & 0x02) != 0) {
		uart_recv();
	}
}

void uart_recv(void) {
	data = *uart_rx;
	uart_send(data+1);
}

void keyboard_recv(void) {

	//char tmp[4] = {0, 0, 0, 0};
	data = scancode2ascii(*keyboard);
	uart_send(data);
	//tmp[0] = data;
	//s_seg (tmp);
}

void uart_send(char character) {
	while ((*uart_tx & 0x100) == 0);
	*uart_tx = character;
}

void uart_send_string(char* string) {
	int i = 0;
	while (string[i]) uart_send(string[i++]);
}

void init(void) {
	// Interrupts aktivieren
	*interrupt_ctrl = 0x07; // Interrupt 1, 2 und 3 (Bit 0, 1 und 2) setzen
	*interrupt_enable = 0x07; // Interrupt 1, 2 und 3 (Bit 0, 1 und 2) aktivieren
	*intIOLED = 0x00;
	*intIOSSEG = 0x00000000;
}

void binary_ctr_step(void)
{
	*intIOLED = *intIOLED + 1;
}

int main()
{
	int i = 0, k = 0, l = 0, iSize = 0;
	char tmp[4] = {0, 0, 0, 0};
	unsigned int x = 0, y = 0;
//	char enable_functions = 0x07; // Bit 0: Lauflicht, Bit 1: Zhler, Bit 3: 7-Segment-Anzeige; 0 und 1 nicht parallel nutzbar!
	char enable_functions = 0x07; // Bit 0: Lauflicht, Bit 1: Zhler, Bit 2: 7-Segment-Anzeige; 0 und 1 nicht parallel nutzbar!

	char *string, *string1;

/*	
while(1)
{
*intIOLED = (*intIOBTN);
}
*/


	init();

	uart_send_string("\n\rHello World!\n\r");

	// VGA farbig ansteuern
	for (i = 0, k = 0; k < 8; i++)
	{
		*vga = k;
		if (i == 50000)
		{
			k++;
			i = 0;
		}
	}
	*vga = 0;


	//strcpy (string, "Hello. Claire... Paul c'est le plus beau");
//strcpy (string, "Hello. Claire... ");
strcpy (string, "ABC01234");

		
iSize = strlen(string);

	// String in SRAM schreiben
	for (i = 0; i < iSize; i = i + 2)  //on range les octets 2 par 2
	{
		for(x = 0; x < 2; x++)
		{
			y = (string[i]  ) << 8;
			k = i + 1;

			if (x == 0)*sram_data = y + string[k] ;
			if (x == 1)*sram_adr = 0x00000000 + i/2; // 31. Bit = 0 := lesen, Bit 0-17: Adresse, hier 0x0
		}
	}
	
	// SRAM auslesen und in string1 schreiben
	for (i = 0, k = 0; i < (iSize/2); i++)
	{
		*sram_adr = 0x80000000 + i;
		for(x = 0; x < 2; x++, k++)
		{
			if (x == 0) string1[k] = *sram_read_data >> 8;
			if (x == 1) string1[k] = *sram_read_data;
		}
	}
	iSize = strlen(string1);


	global_start_index_lauftext = -4;
	i = 0;
	k = 0;
	l = 0;
	while(1)
	{
		// Mittels Schaltern die VGA-Schnittstelle steuern
		*vga = *intIOSW;

/*		// Mittels Schaltern die LEDs auf dem Board steuern
		if ((enable_functions & 0x03) != 0)
		{
			*intIOLED = *intIOSW;
			*intIOLED = (*intIOSW) & 0x7f;
		}
*/
		if (i == 50000)
		{
//bvdp

*intIOLED = k;
k++;

//pour comptage en BCD sur 2 digits 
if ((k & 0x0f) > 9)
  k+=6;
if (((k>>4) & 0x0f) > 9)
  k+=6*16;

//sprintf(string1,"%d",k);
//iSize = strlen(string1);
//uart_send_string(string1	);

uart_send(((k/10000)%10)+'0');
uart_send(((k/1000)%10)+'0');
uart_send(((k/100)%10)+'0');
uart_send(((k/10)%10)+'0');
uart_send(((k/1)%10)+'0');
uart_send('\r');
uart_send('\n');
//k=123;
//sprintf(string1,"%04d",k);

/*
string1[0]='0'+ (k /1000) %10;
string1[1]='0'+ (k /100) %10;
string1[2]='0'+ (k /10) %10;
string1[3]='0'+ (k ) %10;
string1[4]=0;
iSize = strlen(string);
*/

			// Lauftext auf Sieben-Segment-Anzeige
			if ((enable_functions & 0x04) != 0)
			{
				scrolling_text(string1, iSize);
			}
/*
			// Lauflicht
			if ((enable_functions & 0x01) != 0 && (enable_functions & 0x02) == 0)
			{
				if (l == 8)
				{
					l = 0;
					*intIOLED = 0x01;
				}
				else
				{
					*intIOLED = *intIOLED << 1;
				}
				l++;
			}

			//Binrzhler
			if ((enable_functions & 0x02) != 0 && (enable_functions & 0x01) == 0)
			{
				binary_ctr_step();
			}		
*/
			i = 0;
		}
		else
		{
			i++;			
		}
	}
	
	return 0;
}


void scrolling_text(char *string, int iSize)
{
	int k = 0;
	char tmp[4];
	for (k = 0; k < sizeof (tmp); k++)
	{
		tmp[k] = 0;
	}

	if (iSize > 4)
	{
		for (k = 0; k < 4; k++)
		{
			if ((global_start_index_lauftext + k) < 0 || (global_start_index_lauftext + k) > iSize)
			{
				tmp[k] = 0;
			}
			else
			{
				tmp[k] = string[global_start_index_lauftext + k];
			}
		}
		if (global_start_index_lauftext == (iSize))
		{
			global_start_index_lauftext = -4;
		}
		else
		{
			global_start_index_lauftext++;
		}
	}
	else
	{
		strcpy(tmp, string);
	}

	s_seg (tmp);
}


void s_seg(char *string) {
	int i = 0, j = 0;
	*intIOSSEG = 0x00000000;
	while (j < 4)
	{
		i = 3 - j;
		switch (string[j])
		{
		case '0':
			*intIOSSEG += 0x7E << (i * 8);
			break;
		case '1':
			*intIOSSEG += 0x30 << (i * 8);
			break;
		case '2':
			*intIOSSEG += 0x6D << (i * 8);
			break;
		case '3':
			*intIOSSEG += 0x79 << (i * 8);
			break;
		case '4':
			*intIOSSEG += 0x33 << (i * 8);
			break;
		case '5':
			*intIOSSEG += 0x5B << (i * 8);
			break;
		case '6':
			*intIOSSEG += 0x5F << (i * 8);
			break;
		case '7':
			*intIOSSEG += 0x70 << (i * 8);
			break;
		case '8':
			*intIOSSEG += 0x7F << (i * 8);
			break;
		case '9':
			*intIOSSEG += 0x7B << (i * 8);
			break;
		case 'A':
			*intIOSSEG += 0x77 << (i * 8);
			break;			
		case 'a':
			*intIOSSEG += 0x7D << (i * 8);
			break;			
		case 'B':
			*intIOSSEG += 0x7F << (i * 8);
			break;
		case 'b':
			*intIOSSEG += 0x1F << (i * 8);
			break;
		case 'C':
			*intIOSSEG += 0x4E << (i * 8);
			break;
		case 'c':
			*intIOSSEG += 0x0D << (i * 8);
			break;
		case 'D':
			*intIOSSEG += 0x7E << (i * 8);
			break;
		case 'd':
			*intIOSSEG += 0x3D << (i * 8);
			break;
		case 'E':
			*intIOSSEG += 0x4F << (i * 8);
			break;
		case 'e':
			*intIOSSEG += 0x6F << (i * 8);
			break;
		case 'F':
		case 'f':
			*intIOSSEG += 0x47 << (i * 8);
			break;
		case 'G':
			*intIOSSEG += 0x5F << (i * 8);
			break;
		case 'g':
			*intIOSSEG += 0x7B << (i * 8);
			break;
		case 'H':
			*intIOSSEG += 0x37 << (i * 8);
			break;
		case 'h':
			*intIOSSEG += 0x17 << (i * 8);
			break;
		case 'I':
			*intIOSSEG += 0x30 << (i * 8);
			break;
		case 'i':
			*intIOSSEG += 0x04 << (i * 8);
			break;
		case 'J':
			*intIOSSEG += 0x3C << (i * 8);
			break;
		case 'j':
			*intIOSSEG += 0x38 << (i * 8);
			break;
		case 'K':
		case 'k':
			*intIOSSEG += 0x37 << (i * 8);
			break;
		case 'L':
			*intIOSSEG += 0x0E << (i * 8);
			break;
		case 'l':
			*intIOSSEG += 0x06 << (i * 8);
			break;
		case 'M':
		case 'm':
		case 'N':
		case 'n':
			*intIOSSEG += 0x15 << (i * 8);
			break;
		case 'O':
			*intIOSSEG += 0x7E << (i * 8);
			break;
		case 'o':
			*intIOSSEG += 0x1D << (i * 8);
			break;
		case 'P':
		case 'p':
			*intIOSSEG += 0x67 << (i * 8);
			break;
		case 'R':
		case 'r':
			*intIOSSEG += 0x05 << (i * 8);
			break;
		case 'S':
		case 's':
			*intIOSSEG += 0x5B << (i * 8);
			break;
		case 'T':
			*intIOSSEG += 0x46	 << (i * 8);
			break;
		case 't':
			*intIOSSEG += 0x0F	 << (i * 8);
			break;
		case 'U':
		case 'V':
		case 'W':
			*intIOSSEG += 0x3E	 << (i * 8);
			break;
		case 'u':
		case 'v':
		case 'w':
			*intIOSSEG += 0x1C	 << (i * 8);
			break;
		case 'X':
		case 'x':
			*intIOSSEG += 0x37	 << (i * 8);
			break;
		case 'Y':
		case 'y':
			*intIOSSEG += 0x27	 << (i * 8);
			break;
		case 'Z':
		case 'z':
			*intIOSSEG += 0x6D	 << (i * 8);
			break;
		case ' ':
		case 0:
			*intIOSSEG += 0x00	 << (i * 8);
			break;
		case '.':
			*intIOSSEG += 0x80	 << (i * 8);
			break;
		default:
			*intIOSSEG += 0x01	 << (i * 8);
			break;
		}
		j++;
	}
}

int scancode2ascii (int scancode)
{
	switch (scancode)
	{
	case 0x34: // 1
	case 0x4B: // 1 NumPad
		scancode = 0x31;
		break;

	case 0x3C: // 2
	case 0x27: // 2 NumPad
		scancode = 0x32;
		break;

	case 0x32: // 3
	case 0x2F: // 3 NumPad
		scancode = 0x33;
		break;

	case 0x52: // 4
	case 0x6B: // 4 NumPad
		scancode = 0x34;
		break;

	case 0x3A: // 5
	case 0x67: // 5 NumPad
		scancode = 0x35;
		break;

	case 0x36: // 6
	case 0x17: // 6 NumPad
		scancode = 0x36;
		break;

	case 0x5E: // 7
	case 0x1B: // 7 NumPad
		scancode = 0x37;
		break;

	case 0x3E: // 8
	case 0x57: // 8 NumPad
		scancode = 0x38;
		break;

	case 0x31: // 9
	case 0x5F: // 9 NumPad
		scancode = 0x39;
		break;

	case 0x51: // 0
	//case 0x07: // 0 NumPad
		scancode = 0x30;
		break;

	case 0x1C: // A
		scancode = 0x41;
		break;

	case 0x26: // B
		scancode = 0x42;
		break;

	case 0x42: // C
		scancode = 0x43;
		break;

	case 0x62: // D
		scancode = 0x44;
		break;

	case 0x12: // E
		scancode = 0x45;
		break;

	case 0x6A: // F
		scancode = 0x46;
		break;

	case 0x16: // G
		scancode = 0x47;
		break;

	case 0x66: // H
		scancode = 0x48;
		break;

	case 0x61: // I
		scancode = 0x49;
		break;

	case 0x6E: // J
		scancode = 0x4A;
		break;

	case 0x21: // K
		scancode = 0x4B;
		break;

	case 0x69: // L
		scancode = 0x4C;
		break;

	case 0x2E: // M
		scancode = 0x4D;
		break;

	case 0x46: // N
		scancode = 0x4E;
		break;

	case 0x11: // O
		scancode = 0x4F;
		break;

	case 0x59: // P
		scancode = 0x50;
		break;

	case 0x54: // Q
		scancode = 0x51;
		break;

	case 0x5A: // R
		scancode = 0x52;
		break;

	case 0x6C: // S
		scancode = 0x53;
		break;

	case 0x1A: // T
		scancode = 0x54;
		break;

	case 0x1E: // U
		scancode = 0x55;
		break;

	case 0x2A: // V
		scancode = 0x56;
		break;

	case 0x5C: // W
		scancode = 0x57;
		break;

	case 0x22: // X
		scancode = 0x58;
		break;

	case 0x2C: // Y
		scancode = 0x59;
		break;

	case 0x56: // Z
		scancode = 0x5A;
		break;

	case 0x6D: //+
	case 0x4F: //+ NumPad
		scancode = 0x2B;
		break;

	case 0x6F: //- NumPad
		scancode = 0x2D;
		break;

	case 0x38: //^
		scancode = 0x5E;
		break;

	case 0x39: //
		scancode = 0xE1;
		break;

	case 0x33: //Backspace
		scancode = 0x08;
		break;

	case 0x58: //Tab
		scancode = 0x09;//Horizontal Tab
		break;

	case 0x37: //ESC
		scancode = 0x18;
		break;

	case 0x2D: //Return (Line Feed)
		scancode = 0x0A;
		break;

	case 0x24: //Shift Left
	case 0x4D: //Shift Right
		scancode = 0x15;//Shift In
		break;

	case 0x0D: //Caps Lock
		scancode = 0x14;//Shift Out
		break;

	case 0x14: //STRG
		scancode = 0x00;
		break;

	case 0x44: //ALT
		scancode = 0x00;
		break;

	case 0x4A: //Space
		scancode = 0x20;
		break;

	case 0x1F: //* NumPad
		scancode = 0x2A;
		break;

	case 0x47: //, NumPad
		scancode = 0x2C;
		break;

	case 0x15: //
		scancode = 0x9A;
		break;

	case 0x19: //
		scancode = 0x99;
		break;

	case 0x25: //
		scancode = 0xBE;
		break;

	case 0x43: //<
		scancode = 0x3C;
		break;

	case 0x29: //- (Bindestrich)
		scancode = 0x2D;
		break;

	case 0x49: //.
		scancode = 0x2E;
		break;

	case 0x41: //,
		scancode = 0x2C;
		break;

	case 0x5D: //#
		scancode = 0x23;
		break;

	case 0x50: //F1
		scancode = 0x00;
		break;

	case 0x30: //F2
		scancode = 0x00;
		break;

	case 0x10: //F3
		scancode = 0x00;
		break;

	case 0x18: //F4
		scancode = 0x00;
		break;

	case 0x60: //F5
		scancode = 0x00;
		break;

	case 0x68: //F6
		scancode = 0x00;
		break;

/*	case 0x60: //F7 --> gleich wie F5
		scancode = 0x;
		break;
*/
	case 0x28: //F8
		scancode = 0x00;
		break;

	case 0x40: //F9
		scancode = 0x00;
		break;

	case 0x48: //F10
		scancode = 0x00;
		break;

	case 0x0F: //F11
		scancode = 0x00;
		break;

	case 0x70: //F12
		scancode = 0x00;
		break;	

	case 0x03: //Sondertasten werden damit eingeleitet
		scancode = 0x03;
		break;
	}

	return scancode;
}
