library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package uart_pkg is
	component rxunit is
		port(clk		: in  std_logic;
			 reset		: in  std_logic;
			 enable		: in  std_logic;
			 read		: in  std_logic;
			 rxd		: in  std_logic;
			 rxav		: out std_logic;
			 dataOut	: out std_logic_vector(7 downto 0));
	end component rxunit;

	component txunit is
		port(clk		: in  std_logic;
			 reset		: in  std_logic;
			 enable		: in  std_logic;
			 load		: in  std_logic;
			 txd		: out std_logic;
			 busy		: out std_logic;
			 dataIn		: in  std_logic_vector(7 downto 0));
	end component txunit;

	component brgen is
		generic(count	: integer range 0 to 65535);
		port(clk		: in  std_logic;
			 reset		: in  std_logic;
			 ce			: in  std_logic;
			 output		: out std_logic);
	end component brgen;
end package uart_pkg;
